""" MICS 2016 Problem 2 -- Quiz Grader Solution
    
"""

def main():
    numberOfStudents = int(input(""))
    answerString = input("")
    studentResultList = []
    for count in range(numberOfStudents):
        studentLine = input("").upper()
        nameAnswerList = studentLine.strip().split(":")
        nameList = nameAnswerList[0].split(" ")
        studentXOstring = determineXOstring(answerString, nameAnswerList[1])
        studentScore = determineGrade(studentXOstring)
        studentResultList.append((nameList[1], nameList[0], studentScore))
    studentResultList.sort()

    for studentInfo in studentResultList:
        lastName, firstName, score = studentInfo
        print(firstName, lastName, score)

    
def determineXOstring(answerString, studentAnswerString):
    XOstring = ""
    for index in range(len(answerString)):
        if answerString[index] == studentAnswerString[index]:
            XOstring += 'O'
        else:
            XOstring += 'X'
            
    return XOstring
        
def determineGrade(XOstring):
    score = 0
    O_score = 1
    for char in XOstring:
        if char == 'O':
            score += O_score
            O_score += 1
        else:
            O_score = 1
    return score

main()
