""" MICS 2016 Problem 8 -- Secret Message Solution   
"""
alphabet = "abcdefghijklmnopqrstuvwxyz"

def main():
#    keyword = input("").strip().lower()
    inFile = open("prob8in.txt","r")
    keyword = inFile.readline().strip().lower()
#    numberOfLines = int(input("").strip())

    # Build shift amounts for keyword
    shiftAmts = []
    for char in keyword:
        shiftAmts.append(ord(char) - ord('a'))

    position = 0
    numberOfLines = int(inFile.readline().strip())
    for count in range(numberOfLines):
#        inputStr = input("")
        inputLine = inFile.readline().strip()
        line, position = decryptLine(inputLine, position, shiftAmts)
        print(line)

def decryptLine(inputLine, position, shiftAmts):
    line = ""
    for char in inputLine:
        if char >= 'A' and char <= 'Z':
            isUpperCase = True
            char = char.lower()
        else:
            isUpperCase = False
        if char >= 'a' and char <= 'z':
            decodedChar = alphabet[ord(char) - ord('a') - shiftAmts[position%len(shiftAmts)]]
            position = position + 1
            if isUpperCase:
                line += decodedChar.upper()
            else:
                line += decodedChar
        else:
            line += char
    return line, position
                
main()
