""" MICS 2016 Programming Contest Problem 3 -- Word Jumble Solution
"""

def main():
    # Get Jumbled words
#    numberOfWords = int(input(""))
    inFile = open("prob3in.txt","r")
    numberOfWords = int(inFile.readline().strip())
    wordList = []
    for count in range(numberOfWords):
#        word = input("").strip().lower()
        word = inFile.readline().strip().lower()
        wordList.append(word)

    # Get dictionary words
    dictionaryDictByWordLength = {}
#    numberOfDictionaryWords = int(input(""))
    numberOfDictionaryWords = int(inFile.readline())
    for count in range(numberOfDictionaryWords):
#        word = input("").strip().lower()
        word = inFile.readline().strip().lower()
        wordLength = len(word)
        if wordLength in dictionaryDictByWordLength:
            dictionaryDictByWordLength[wordLength].append(word)
        else:
            dictionaryDictByWordLength[wordLength] = [word]
            
    # Process Jumbled words
    for word in wordList:
        print(word+":", end="",sep="")
        listOfDictionaryWords = dictionaryDictByWordLength[len(word)]
        matchFound = False
        for dictWord in listOfDictionaryWords:
            if isAnagram(word, dictWord):
                matchFound = True
                print(" "+ dictWord, end="",sep="")
        if matchFound:
            print()
        else:
            print(" no match in dictionary")
    
def isAnagram(word1, word2):
    word1 = word1.lower()
    word1List = []
    for char in word1:
        word1List.append(char)

    word2 = word2.lower()
    word2List = []
    for char in word2:
        word2List.append(char)
    
    if len(word1) != len(word2):
        return False
    else:
        index = 0
        word1List.sort()
        word2List.sort()
        while index < len(word1List):
            if word1List[index] != word2List[index]:
                return False
            else:
                index += 1
        return True             
main()

